diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/list-scheduler.cc ns-3.40/src/core/model/list-scheduler.cc
--- ns-3.39/src/core/model/list-scheduler.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/list-scheduler.cc	2023-09-27 13:30:37.630839000 -0700
@@ -62,7 +62,7 @@
 ListScheduler::Insert(const Event& ev)
 {
     NS_LOG_FUNCTION(this << &ev);
-    for (EventsI i = m_events.begin(); i != m_events.end(); i++)
+    for (auto i = m_events.begin(); i != m_events.end(); i++)
     {
         if (ev.key < i->key)
         {
@@ -100,7 +100,7 @@
 ListScheduler::Remove(const Event& ev)
 {
     NS_LOG_FUNCTION(this << &ev);
-    for (EventsI i = m_events.begin(); i != m_events.end(); i++)
+    for (auto i = m_events.begin(); i != m_events.end(); i++)
     {
         if (i->key.m_uid == ev.key.m_uid)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/log.cc ns-3.40/src/core/model/log.cc
--- ns-3.39/src/core/model/log.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/log.cc	2023-09-27 13:30:37.630839000 -0700
@@ -247,7 +247,7 @@
 LogComponent::IsEnabled(const LogLevel level) const
 {
     //  LogComponentEnableEnvVar ();
-    return (level & m_levels) ? 1 : 0;
+    return level & m_levels;
 }
 
 bool
@@ -320,9 +320,7 @@
 LogComponentEnableAll(LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
-    for (LogComponent::ComponentList::const_iterator i = components->begin();
-         i != components->end();
-         i++)
+    for (auto i = components->begin(); i != components->end(); i++)
     {
         i->second->Enable(level);
     }
@@ -344,9 +342,7 @@
 LogComponentDisableAll(LogLevel level)
 {
     LogComponent::ComponentList* components = LogComponent::GetComponentList();
-    for (LogComponent::ComponentList::const_iterator i = components->begin();
-         i != components->end();
-         i++)
+    for (auto i = components->begin(); i != components->end(); i++)
     {
         i->second->Disable(level);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/map-scheduler.cc ns-3.40/src/core/model/map-scheduler.cc
--- ns-3.39/src/core/model/map-scheduler.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/map-scheduler.cc	2023-09-27 13:30:37.630839000 -0700
@@ -79,7 +79,7 @@
 MapScheduler::PeekNext() const
 {
     NS_LOG_FUNCTION(this);
-    EventMapCI i = m_list.begin();
+    auto i = m_list.begin();
     NS_ASSERT(i != m_list.end());
 
     Event ev;
@@ -93,7 +93,7 @@
 MapScheduler::RemoveNext()
 {
     NS_LOG_FUNCTION(this);
-    EventMapI i = m_list.begin();
+    auto i = m_list.begin();
     NS_ASSERT(i != m_list.end());
     Event ev;
     ev.impl = i->second;
@@ -107,7 +107,7 @@
 MapScheduler::Remove(const Event& ev)
 {
     NS_LOG_FUNCTION(this << ev.impl << ev.key.m_ts << ev.key.m_uid);
-    EventMapI i = m_list.find(ev.key);
+    auto i = m_list.find(ev.key);
     NS_ASSERT(i->second == ev.impl);
     m_list.erase(i);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/matrix-array.h ns-3.40/src/core/model/matrix-array.h
--- ns-3.39/src/core/model/matrix-array.h	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/matrix-array.h	2023-09-27 13:30:37.630839000 -0700
@@ -243,8 +243,7 @@
      * \return Returns a new matrix that is the result of the Hermitian transpose
      */
     template <bool EnableBool = true,
-              typename = typename std::enable_if<(std::is_same<T, std::complex<double>>::value &&
-                                                  EnableBool)>::type>
+              typename = std::enable_if_t<(std::is_same_v<T, std::complex<double>> && EnableBool)>>
     MatrixArray<T> HermitianTranspose() const;
 
   protected:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/names.cc ns-3.40/src/core/model/names.cc
--- ns-3.39/src/core/model/names.cc	2023-07-05 14:23:47.757427200 -0700
+++ ns-3.40/src/core/model/names.cc	2023-09-27 13:30:37.630839000 -0700
@@ -303,8 +303,7 @@
     // Every name is associated with an object in the object map, so freeing the
     // NameNodes in this map will free all of the memory allocated for the NameNodes
     //
-    for (std::map<Ptr<Object>, NameNode*>::iterator i = m_objectMap.begin(); i != m_objectMap.end();
-         ++i)
+    for (auto i = m_objectMap.begin(); i != m_objectMap.end(); ++i)
     {
         delete i->second;
         i->second = nullptr;
@@ -420,7 +419,7 @@
         return false;
     }
 
-    NameNode* newNode = new NameNode(node, name, object);
+    auto newNode = new NameNode(node, name, object);
     node->m_nameMap[name] = newNode;
     m_objectMap[object] = newNode;
 
@@ -525,7 +524,7 @@
         return false;
     }
 
-    std::map<std::string, NameNode*>::iterator i = node->m_nameMap.find(oldname);
+    auto i = node->m_nameMap.find(oldname);
     if (i == node->m_nameMap.end())
     {
         NS_LOG_LOGIC("Old name does not exist in name map");
@@ -555,7 +554,7 @@
 {
     NS_LOG_FUNCTION(this << object);
 
-    std::map<Ptr<Object>, NameNode*>::iterator i = m_objectMap.find(object);
+    auto i = m_objectMap.find(object);
     if (i == m_objectMap.end())
     {
         NS_LOG_LOGIC("Object does not exist in object map");
@@ -573,7 +572,7 @@
 {
     NS_LOG_FUNCTION(this << object);
 
-    std::map<Ptr<Object>, NameNode*>::iterator i = m_objectMap.find(object);
+    auto i = m_objectMap.find(object);
     if (i == m_objectMap.end())
     {
         NS_LOG_LOGIC("Object does not exist in object map");
@@ -648,7 +647,7 @@
             // There are no remaining slashes so this is the last segment of the
             // specified name.  We're done when we find it
             //
-            std::map<std::string, NameNode*>::iterator i = node->m_nameMap.find(remaining);
+            auto i = node->m_nameMap.find(remaining);
             if (i == node->m_nameMap.end())
             {
                 NS_LOG_LOGIC("Name does not exist in name map");
@@ -669,7 +668,7 @@
             offset = remaining.find('/');
             std::string segment = remaining.substr(0, offset);
 
-            std::map<std::string, NameNode*>::iterator i = node->m_nameMap.find(segment);
+            auto i = node->m_nameMap.find(segment);
             if (i == node->m_nameMap.end())
             {
                 NS_LOG_LOGIC("Name does not exist in name map");
@@ -723,7 +722,7 @@
         }
     }
 
-    std::map<std::string, NameNode*>::iterator i = node->m_nameMap.find(name);
+    auto i = node->m_nameMap.find(name);
     if (i == node->m_nameMap.end())
     {
         NS_LOG_LOGIC("Name does not exist in name map");
@@ -741,7 +740,7 @@
 {
     NS_LOG_FUNCTION(this << object);
 
-    std::map<Ptr<Object>, NameNode*>::iterator i = m_objectMap.find(object);
+    auto i = m_objectMap.find(object);
     if (i == m_objectMap.end())
     {
         NS_LOG_LOGIC("Object does not exist in object map, returning NameNode 0");
@@ -759,7 +758,7 @@
 {
     NS_LOG_FUNCTION(this << node << name);
 
-    std::map<std::string, NameNode*>::iterator i = node->m_nameMap.find(name);
+    auto i = node->m_nameMap.find(name);
     if (i == node->m_nameMap.end())
     {
         NS_LOG_LOGIC("Name does not exist in name map");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/nstime.h ns-3.40/src/core/model/nstime.h
--- ns-3.39/src/core/model/nstime.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/nstime.h	2023-09-27 13:30:37.630839000 -0700
@@ -580,7 +580,7 @@
 
         NS_ASSERT_MSG(info->isValid, "Attempted a conversion to an unavailable unit.");
 
-        int64x64_t retval = int64x64_t(m_data);
+        int64x64_t retval(m_data);
         if (info->toMul)
         {
             retval *= info->timeTo;
@@ -792,21 +792,15 @@
     friend Time Rem(const Time& lhs, const Time& rhs);
 
     template <class T>
-    friend typename std::enable_if<std::is_integral<T>::value, Time>::type operator*(
-        const Time& lhs,
-        T rhs);
+    friend std::enable_if_t<std::is_integral_v<T>, Time> operator*(const Time& lhs, T rhs);
 
     // Reversed arg version (forwards to `rhs * lhs`)
     // Accepts both integers and decimal types
     template <class T>
-    friend typename std::enable_if<std::is_arithmetic<T>::value, Time>::type operator*(
-        T lhs,
-        const Time& rhs);
+    friend std::enable_if_t<std::is_arithmetic_v<T>, Time> operator*(T lhs, const Time& rhs);
 
     template <class T>
-    friend typename std::enable_if<std::is_integral<T>::value, Time>::type operator/(
-        const Time& lhs,
-        T rhs);
+    friend std::enable_if_t<std::is_integral_v<T>, Time> operator/(const Time& lhs, T rhs);
 
     friend Time Abs(const Time& time);
     friend Time Max(const Time& timeA, const Time& timeB);
@@ -816,13 +810,9 @@
 
     // Leave undocumented
     template <class T>
-    friend typename std::enable_if<std::is_floating_point<T>::value, Time>::type operator*(
-        const Time& lhs,
-        T rhs);
+    friend std::enable_if_t<std::is_floating_point_v<T>, Time> operator*(const Time& lhs, T rhs);
     template <class T>
-    friend typename std::enable_if<std::is_floating_point<T>::value, Time>::type operator/(
-        const Time& lhs,
-        T rhs);
+    friend std::enable_if_t<std::is_floating_point_v<T>, Time> operator/(const Time& lhs, T rhs);
 
     /**
      * \name Compound assignment operators
@@ -1017,18 +1007,17 @@
  * \returns A new Time instance containing the scaled value
  */
 template <class T>
-typename std::enable_if<std::is_integral<T>::value, Time>::type
+std::enable_if_t<std::is_integral_v<T>, Time>
 operator*(const Time& lhs, T rhs)
 {
-    static_assert(!std::is_same<T, bool>::value,
-                  "Multiplying a Time by a boolean is not supported");
+    static_assert(!std::is_same_v<T, bool>, "Multiplying a Time by a boolean is not supported");
 
     return Time(lhs.m_data * rhs);
 }
 
 // Leave undocumented
 template <class T>
-typename std::enable_if<std::is_floating_point<T>::value, Time>::type
+std::enable_if_t<std::is_floating_point_v<T>, Time>
 operator*(const Time& lhs, T rhs)
 {
     return lhs * int64x64_t(rhs);
@@ -1048,7 +1037,7 @@
  * \returns A new Time instance containing the scaled value
  */
 template <class T>
-typename std::enable_if<std::is_arithmetic<T>::value, Time>::type
+std::enable_if_t<std::is_arithmetic_v<T>, Time>
 operator*(T lhs, const Time& rhs)
 {
     return rhs * lhs;
@@ -1104,17 +1093,17 @@
  * \returns A new Time instance containing the scaled value
  */
 template <class T>
-typename std::enable_if<std::is_integral<T>::value, Time>::type
+std::enable_if_t<std::is_integral_v<T>, Time>
 operator/(const Time& lhs, T rhs)
 {
-    static_assert(!std::is_same<T, bool>::value, "Dividing a Time by a boolean is not supported");
+    static_assert(!std::is_same_v<T, bool>, "Dividing a Time by a boolean is not supported");
 
     return Time(lhs.m_data / rhs);
 }
 
 // Leave undocumented
 template <class T>
-typename std::enable_if<std::is_floating_point<T>::value, Time>::type
+std::enable_if_t<std::is_floating_point_v<T>, Time>
 operator/(const Time& lhs, T rhs)
 {
     return lhs / int64x64_t(rhs);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-base.cc ns-3.40/src/core/model/object-base.cc
--- ns-3.39/src/core/model/object-base.cc	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-base.cc	2023-09-27 13:30:37.630839000 -0700
@@ -35,6 +35,10 @@
 
 namespace ns3
 {
+// Explicit instantiation declaration
+template Callback<ObjectBase*> MakeCallback<ObjectBase*>(ObjectBase* (*)());
+template Callback<ObjectBase*>::Callback();
+template class CallbackImpl<ObjectBase*>;
 
 NS_LOG_COMPONENT_DEFINE("ObjectBase");
 
@@ -257,7 +261,7 @@
     {
         return;
     }
-    StringValue* str = dynamic_cast<StringValue*>(&value);
+    auto str = dynamic_cast<StringValue*>(&value);
     if (str == nullptr)
     {
         NS_FATAL_ERROR("Attribute name=" << name << " tid=" << tid.GetName()
@@ -292,7 +296,7 @@
     {
         return true;
     }
-    StringValue* str = dynamic_cast<StringValue*>(&value);
+    auto str = dynamic_cast<StringValue*>(&value);
     if (str == nullptr)
     {
         return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-base.h ns-3.40/src/core/model/object-base.h
--- ns-3.39/src/core/model/object-base.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-base.h	2023-09-27 13:30:37.630839000 -0700
@@ -335,6 +335,15 @@
                const AttributeValue& value);
 };
 
+// The following explicit template instantiation declarations prevent all the translation
+// units including this header file to implicitly instantiate the callbacks class and
+// function templates having ObjectBase as template type parameter that are required to be
+// instantiated more often (accorging to the ClangBuildAnalyzer tool).
+// These classes and functions are explicitly instantiated in object-base.cc
+extern template Callback<ObjectBase*> MakeCallback<ObjectBase*>(ObjectBase* (*)());
+extern template Callback<ObjectBase*>::Callback();
+extern template class CallbackImpl<ObjectBase*>;
+
 } // namespace ns3
 
 #endif /* OBJECT_BASE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object.cc ns-3.40/src/core/model/object.cc
--- ns-3.39/src/core/model/object.cc	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object.cc	2023-09-27 13:30:37.630839000 -0700
@@ -267,8 +267,7 @@
     Object* other = PeekPointer(o);
     // first create the new aggregate buffer.
     uint32_t total = m_aggregates->n + other->m_aggregates->n;
-    Aggregates* aggregates =
-        (Aggregates*)std::malloc(sizeof(Aggregates) + (total - 1) * sizeof(Object*));
+    auto aggregates = (Aggregates*)std::malloc(sizeof(Aggregates) + (total - 1) * sizeof(Object*));
     aggregates->n = total;
 
     // copy our buffer to the new buffer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-factory.cc ns-3.40/src/core/model/object-factory.cc
--- ns-3.39/src/core/model/object-factory.cc	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-factory.cc	2023-09-27 13:30:37.630839000 -0700
@@ -95,7 +95,7 @@
     NS_LOG_FUNCTION(this);
     Callback<ObjectBase*> cb = m_tid.GetConstructor();
     ObjectBase* base = cb();
-    Object* derived = dynamic_cast<Object*>(base);
+    auto derived = dynamic_cast<Object*>(base);
     NS_ASSERT(derived != nullptr);
     derived->SetTypeId(m_tid);
     derived->Construct(m_parameters);
@@ -108,9 +108,7 @@
 {
     os << factory.m_tid.GetName() << "[";
     bool first = true;
-    for (AttributeConstructionList::CIterator i = factory.m_parameters.Begin();
-         i != factory.m_parameters.End();
-         ++i)
+    for (auto i = factory.m_parameters.Begin(); i != factory.m_parameters.End(); ++i)
     {
         os << i->name << "=" << i->value->SerializeToString(i->checker);
         if (first)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-map.h ns-3.40/src/core/model/object-map.h
--- ns-3.39/src/core/model/object-map.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-map.h	2023-09-27 13:30:37.630839000 -0700
@@ -93,10 +93,10 @@
                           std::size_t* index) const override
         {
             const T* obj = static_cast<const T*>(object);
-            typename U::const_iterator begin = (obj->*m_memberVector).begin();
-            typename U::const_iterator end = (obj->*m_memberVector).end();
+            auto begin = (obj->*m_memberVector).begin();
+            auto end = (obj->*m_memberVector).end();
             uint32_t k = 0;
-            for (typename U::const_iterator j = begin; j != end; j++, k++)
+            for (auto j = begin; j != end; j++, k++)
             {
                 if (k == i)
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-ptr-container.cc ns-3.40/src/core/model/object-ptr-container.cc
--- ns-3.39/src/core/model/object-ptr-container.cc	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-ptr-container.cc	2023-09-27 13:30:37.630839000 -0700
@@ -61,7 +61,7 @@
 ObjectPtrContainerValue::Get(std::size_t i) const
 {
     NS_LOG_FUNCTION(this << i);
-    Iterator it = m_objects.find(i);
+    auto it = m_objects.find(i);
     Ptr<Object> value = nullptr;
     if (it != m_objects.end())
     {
@@ -115,7 +115,7 @@
 ObjectPtrContainerAccessor::Get(const ObjectBase* object, AttributeValue& value) const
 {
     NS_LOG_FUNCTION(this << object << &value);
-    ObjectPtrContainerValue* v = dynamic_cast<ObjectPtrContainerValue*>(&value);
+    auto v = dynamic_cast<ObjectPtrContainerValue*>(&value);
     if (v == nullptr)
     {
         return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-ptr-container.h ns-3.40/src/core/model/object-ptr-container.h
--- ns-3.39/src/core/model/object-ptr-container.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-ptr-container.h	2023-09-27 13:30:37.630839000 -0700
@@ -208,8 +208,8 @@
 
     bool Copy(const AttributeValue& source, AttributeValue& destination) const override
     {
-        const ObjectPtrContainerValue* src = dynamic_cast<const ObjectPtrContainerValue*>(&source);
-        ObjectPtrContainerValue* dst = dynamic_cast<ObjectPtrContainerValue*>(&destination);
+        const auto src = dynamic_cast<const ObjectPtrContainerValue*>(&source);
+        auto dst = dynamic_cast<ObjectPtrContainerValue*>(&destination);
         if (src == nullptr || dst == nullptr)
         {
             return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/object-vector.h ns-3.40/src/core/model/object-vector.h
--- ns-3.39/src/core/model/object-vector.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/object-vector.h	2023-09-27 13:30:37.630839000 -0700
@@ -93,10 +93,10 @@
                           std::size_t* index) const override
         {
             const T* obj = static_cast<const T*>(object);
-            typename U::const_iterator begin = (obj->*m_memberVector).begin();
-            typename U::const_iterator end = (obj->*m_memberVector).end();
+            auto begin = (obj->*m_memberVector).begin();
+            auto end = (obj->*m_memberVector).end();
             std::size_t k = 0;
-            for (typename U::const_iterator j = begin; j != end; j++, k++)
+            for (auto j = begin; j != end; j++, k++)
             {
                 if (k == i)
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/pair.h ns-3.40/src/core/model/pair.h
--- ns-3.39/src/core/model/pair.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/pair.h	2023-09-27 13:30:37.630839000 -0700
@@ -20,8 +20,8 @@
 #ifndef PAIR_H
 #define PAIR_H
 
-#include <ns3/attribute-helper.h>
-#include <ns3/string.h>
+#include "attribute-helper.h"
+#include "string.h"
 
 #include <sstream>
 #include <type_traits>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/pointer.h ns-3.40/src/core/model/pointer.h
--- ns-3.39/src/core/model/pointer.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/pointer.h	2023-09-27 13:30:37.630839000 -0700
@@ -129,7 +129,7 @@
 {
     bool Check(const AttributeValue& val) const override
     {
-        const PointerValue* value = dynamic_cast<const PointerValue*>(&val);
+        const auto value = dynamic_cast<const PointerValue*>(&val);
         if (value == nullptr)
         {
             return false;
@@ -166,8 +166,8 @@
 
     bool Copy(const AttributeValue& source, AttributeValue& destination) const override
     {
-        const PointerValue* src = dynamic_cast<const PointerValue*>(&source);
-        PointerValue* dst = dynamic_cast<PointerValue*>(&destination);
+        const auto src = dynamic_cast<const PointerValue*>(&source);
+        auto dst = dynamic_cast<PointerValue*>(&destination);
         if (src == nullptr || dst == nullptr)
         {
             return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/priority-queue-scheduler.h ns-3.40/src/core/model/priority-queue-scheduler.h
--- ns-3.39/src/core/model/priority-queue-scheduler.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/priority-queue-scheduler.h	2023-09-27 13:30:37.630839000 -0700
@@ -90,7 +90,7 @@
      */
     class EventPriorityQueue : public std::priority_queue<Scheduler::Event,
                                                           std::vector<Scheduler::Event>,
-                                                          std::greater<Scheduler::Event>>
+                                                          std::greater<>>
     {
       public:
         /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/ptr.h ns-3.40/src/core/model/ptr.h
--- ns-3.39/src/core/model/ptr.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/ptr.h	2023-09-27 13:30:37.630839000 -0700
@@ -332,9 +332,7 @@
  * \copydoc operator==(Ptr<T1>const&,Ptr<T2>const&)
  */
 template <typename T1, typename T2>
-typename std::enable_if<std::is_same<T2, std::nullptr_t>::value, bool>::type operator==(
-    const Ptr<T1>& lhs,
-    T2 rhs);
+std::enable_if_t<std::is_same_v<T2, std::nullptr_t>, bool> operator==(const Ptr<T1>& lhs, T2 rhs);
 
 /**
  * \ingroup ptr
@@ -373,9 +371,7 @@
  * \copydoc operator==(Ptr<T1>const&,Ptr<T2>const&)
  */
 template <typename T1, typename T2>
-typename std::enable_if<std::is_same<T2, std::nullptr_t>::value, bool>::type operator!=(
-    const Ptr<T1>& lhs,
-    T2 rhs);
+std::enable_if_t<std::is_same_v<T2, std::nullptr_t>, bool> operator!=(const Ptr<T1>& lhs, T2 rhs);
 
 /**
  * \ingroup ptr
@@ -549,14 +545,14 @@
 }
 
 template <typename T1, typename T2>
-typename std::enable_if<std::is_same<T2, std::nullptr_t>::value, bool>::type
+std::enable_if_t<std::is_same_v<T2, std::nullptr_t>, bool>
 operator==(const Ptr<T1>& lhs, T2 rhs)
 {
     return PeekPointer(lhs) == nullptr;
 }
 
 template <typename T1, typename T2>
-typename std::enable_if<std::is_same<T2, std::nullptr_t>::value, bool>::type
+std::enable_if_t<std::is_same_v<T2, std::nullptr_t>, bool>
 operator!=(const Ptr<T1>& lhs, T2 rhs)
 {
     return PeekPointer(lhs) != nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/random-variable-stream.cc ns-3.40/src/core/model/random-variable-stream.cc
--- ns-3.39/src/core/model/random-variable-stream.cc	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/random-variable-stream.cc	2023-09-27 13:30:37.630839000 -0700
@@ -421,7 +421,7 @@
 ExponentialRandomVariable::GetValue(double mean, double bound)
 {
     NS_LOG_FUNCTION(this << mean << bound);
-    while (1)
+    while (true)
     {
         // Get a uniform random variable in [0,1].
         double v = Peek()->RandU01();
@@ -520,7 +520,7 @@
     // Calculate the scale parameter.
     NS_LOG_FUNCTION(this << scale << shape << bound);
 
-    while (1)
+    while (true)
     {
         // Get a uniform random variable in [0,1].
         double v = Peek()->RandU01();
@@ -617,7 +617,7 @@
 {
     NS_LOG_FUNCTION(this << scale << shape << bound);
     double exponent = 1.0 / shape;
-    while (1)
+    while (true)
     {
         // Get a uniform random variable in [0,1].
         double v = Peek()->RandU01();
@@ -724,7 +724,7 @@
             return x2;
         }
     }
-    while (1)
+    while (true)
     { // See Simulation Modeling and Analysis p. 466 (Averill Law)
         // for algorithm; basically a Box-Muller transform:
         // http://en.wikipedia.org/wiki/Box-Muller_transform
@@ -992,7 +992,7 @@
     double d = alpha - 1.0 / 3.0;
     double c = (1.0 / 3.0) / std::sqrt(d);
 
-    while (1)
+    while (true)
     {
         do
         {
@@ -1045,7 +1045,7 @@
             return x2;
         }
     }
-    while (1)
+    while (true)
     { // See Simulation Modeling and Analysis p. 466 (Averill Law)
         // for algorithm; basically a Box-Muller transform:
         // http://en.wikipedia.org/wiki/Box-Muller_transform
@@ -1173,7 +1173,7 @@
 ErlangRandomVariable::GetExponentialValue(double mean, double bound)
 {
     NS_LOG_FUNCTION(this << mean << bound);
-    while (1)
+    while (true)
     {
         // Get a uniform random variable in [0,1].
         double v = Peek()->RandU01();
@@ -1534,28 +1534,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(EmpiricalRandomVariable);
 
-// ValueCDF methods
-EmpiricalRandomVariable::ValueCDF::ValueCDF()
-    : value(0.0),
-      cdf(0.0)
-{
-    NS_LOG_FUNCTION(this);
-}
-
-EmpiricalRandomVariable::ValueCDF::ValueCDF(double v, double c)
-    : value(v),
-      cdf(c)
-{
-    NS_LOG_FUNCTION(this << v << c);
-    NS_ASSERT(c >= 0.0 && c <= 1.0);
-}
-
-bool
-operator<(EmpiricalRandomVariable::ValueCDF a, EmpiricalRandomVariable::ValueCDF b)
-{
-    return a.cdf < b.cdf;
-}
-
 TypeId
 EmpiricalRandomVariable::GetTypeId()
 {
@@ -1608,14 +1586,14 @@
     value = r;
     bool valid = false;
     // check extrema
-    if (r <= m_emp.front().cdf)
+    if (r <= m_empCdf.begin()->first)
     {
-        value = m_emp.front().value; // Less than first
+        value = m_empCdf.begin()->second; // Less than first
         valid = true;
     }
-    else if (r >= m_emp.back().cdf)
+    else if (r >= m_empCdf.rbegin()->first)
     {
-        value = m_emp.back().value; // Greater than last
+        value = m_empCdf.rbegin()->second; // Greater than last
         valid = true;
     }
     return valid;
@@ -1649,10 +1627,10 @@
 {
     NS_LOG_FUNCTION(this << r);
 
-    ValueCDF selector(0, r);
-    auto bound = std::upper_bound(m_emp.begin(), m_emp.end(), selector);
+    // Find first CDF that is greater than r
+    auto bound = m_empCdf.upper_bound(r);
 
-    return bound->value;
+    return bound->second;
 }
 
 double
@@ -1680,19 +1658,19 @@
     // This code based (loosely) on code by Bruce Mah (Thanks Bruce!)
 
     // search
-    ValueCDF selector(0, r);
-    auto upper = std::upper_bound(m_emp.begin(), m_emp.end(), selector);
+    auto upper = m_empCdf.upper_bound(r);
     auto lower = std::prev(upper, 1);
-    if (upper == m_emp.begin())
+
+    if (upper == m_empCdf.begin())
     {
         lower = upper;
     }
 
     // Interpolate random value in range [v1..v2) based on [c1 .. r .. c2)
-    double c1 = lower->cdf;
-    double c2 = upper->cdf;
-    double v1 = lower->value;
-    double v2 = upper->value;
+    double c1 = lower->first;
+    double c2 = upper->first;
+    double v1 = lower->second;
+    double v2 = upper->second;
 
     double value = (v1 + ((v2 - v1) / (c2 - c1)) * (r - c1));
     return value;
@@ -1701,36 +1679,62 @@
 void
 EmpiricalRandomVariable::CDF(double v, double c)
 {
-    // Add a new empirical datapoint to the empirical cdf
-    // NOTE.   These MUST be inserted in non-decreasing order
     NS_LOG_FUNCTION(this << v << c);
-    m_emp.emplace_back(v, c);
+
+    auto vPrevious = m_empCdf.find(c);
+
+    if (vPrevious != m_empCdf.end())
+    {
+        NS_LOG_WARN("Empirical CDF already has a value " << vPrevious->second << " for CDF " << c
+                                                         << ". Overwriting it with value " << v
+                                                         << ".");
+    }
+
+    m_empCdf[c] = v;
 }
 
 void
 EmpiricalRandomVariable::Validate()
 {
     NS_LOG_FUNCTION(this);
-    if (m_emp.empty())
+
+    if (m_empCdf.empty())
     {
         NS_FATAL_ERROR("CDF is not initialized");
     }
-    ValueCDF prior = m_emp[0];
-    for (auto current : m_emp)
+
+    double vPrev = m_empCdf.begin()->second;
+
+    // Check if values are non-decreasing
+    for (const auto& cdfPair : m_empCdf)
     {
-        if (current.value < prior.value || current.cdf < prior.cdf)
-        { // Error
-            std::cerr << "Empirical Dist error,"
-                      << " current value " << current.value << " prior value " << prior.value
-                      << " current cdf " << current.cdf << " prior cdf " << prior.cdf << std::endl;
-            NS_FATAL_ERROR("Empirical Dist error");
+        const auto& vCurr = cdfPair.second;
+
+        if (vCurr < vPrev)
+        {
+            NS_FATAL_ERROR("Empirical distribution has decreasing CDF values. Current CDF: "
+                           << vCurr << ", prior CDF: " << vPrev);
         }
-        prior = current;
+
+        vPrev = vCurr;
     }
-    if (prior.cdf != 1.0)
+
+    // Bounds check on CDF endpoints
+    auto firstCdfPair = m_empCdf.begin();
+    auto lastCdfPair = m_empCdf.rbegin();
+
+    if (firstCdfPair->first < 0.0)
     {
-        NS_FATAL_ERROR("CDF does not cover the whole distribution");
+        NS_FATAL_ERROR("Empirical distribution has invalid first CDF value. CDF: "
+                       << firstCdfPair->first << ", Value: " << firstCdfPair->second);
     }
+
+    if (lastCdfPair->first > 1.0)
+    {
+        NS_FATAL_ERROR("Empirical distribution has invalid last CDF value. CDF: "
+                       << lastCdfPair->first << ", Value: " << lastCdfPair->second);
+    }
+
     m_validated = true;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/core/model/random-variable-stream.h ns-3.40/src/core/model/random-variable-stream.h
--- ns-3.39/src/core/model/random-variable-stream.h	2023-07-05 14:23:47.761427200 -0700
+++ ns-3.40/src/core/model/random-variable-stream.h	2023-09-27 13:30:37.630839000 -0700
@@ -29,6 +29,7 @@
 #include "object.h"
 #include "type-id.h"
 
+#include <map>
 #include <stdint.h>
 
 /**
@@ -1983,7 +1984,6 @@
 
     /**
      * \brief Specifies a point in the empirical distribution
-     * \note These *MUST* be inserted in ascending order of \p c
      *
      * \param [in] v The function value for this point
      * \param [in] c Probability that the function is less than or equal to \p v
@@ -2018,26 +2018,6 @@
     bool SetInterpolate(bool interpolate);
 
   private:
-    /** \brief Helper to hold one point of the CDF. */
-    class ValueCDF
-    {
-      public:
-        /** \brief Constructor. */
-        ValueCDF();
-        /**
-         * \brief Construct from values.
-         *
-         * \param [in] v The argument value.
-         * \param [in] c The CDF at the argument value \pname{v}
-         */
-        ValueCDF(double v, double c);
-
-        /** The argument value. */
-        double value;
-        /** The CDF at \pname{value}  */
-        double cdf;
-    }; // class ValueCDF
-
     /**
      * \brief Check that the CDF is valid.
      *
@@ -2078,18 +2058,14 @@
      */
     double DoInterpolate(double r);
 
-    /**
-     * \brief Comparison operator, for use by std::upper_bound
-     * \param a [in] the first value
-     * \param b [in] the second value
-     * \returns \c true if \c a.cdf < \c b.cdf
-     */
-    friend bool operator<(ValueCDF a, ValueCDF b);
-
     /** \c true once the CDF has been validated. */
     bool m_validated;
-    /** The vector of CDF points. */
-    std::vector<ValueCDF> m_emp;
+    /**
+     * The map of CDF points (x, F(x)).
+     * The CDF points are stored in the std::map in reverse order, as follows:
+     * Key: CDF F(x) [0, 1] | Value: domain value (x) [-inf, inf].
+     */
+    std::map<double, double> m_empCdf;
     /**
      * If \c true GetValue will interpolate,
      * otherwise treat CDF as normal histogram.
